package com.ichaoj.ams.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ichaoj.ams.entity.AmsTradeRecord;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ichaoj.ams.request.record.PageTradeRecordRequest;
import com.ichaoj.ams.response.count.DailyCostResponse;
import com.ichaoj.ams.response.record.TradeRecordResponse;

import java.util.List;

/**
 * <p>
 * 交易 Mapper 接口
 * </p>
 *
 * @author cjwen
 * @since 2023-05-18
 */
public interface AmsTradeRecordMapper extends BaseMapper<AmsTradeRecord> {

    /**
     * 分页查询交易记录
     *
     * @param buildPageObj 分页对象
     * @param request      请求参数
     * @return 分页结果
     */
    Page<TradeRecordResponse> pageTradeRecord(Page<AmsTradeRecord> buildPageObj, PageTradeRecordRequest request);

    /**
     * 统计每日消耗gas和本金
     *
     * @param startTime 开始时间
     * @param endTime   结束时间
     * @return 统计数据
     */
    List<DailyCostResponse> dailyCostStatistics();
}
